using System;
using UnityEngine;
using UnityEngine.Events;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Reflection;
using System.Text;
using UnityEngine.SceneManagement;

public class DebugAPI : MonoBehaviour { 
    public static List<string> GetAllObjectsList() { 
        GameObject[] AllObjs = UnityEngine.Object.FindObjectsOfType<GameObject>();
        List<string> ObjList = new List<string>();
        
        foreach (var obj in AllObjs) {
            string ObjInfo = "Name: " + obj.name + ", SpriteRenderer sprite: " + obj.GetComponent<SpriteRenderer>().sprite + ", Size: " + obj.transform.localScale + ", Tag: " + obj.tag + ", Layer: " + obj.layer + ", Shader: " + obj.GetComponent<Renderer>().material.shader;
            ObjList.Add(ObjInfo);
        }
        return ObjList;
    }
    public static GameObject[] GetAllGameObjects() { 
        return UnityEngine.Object.FindObjectsOfType<GameObject>();
    }
    public static List<string> GetShaderProperties(GameObject Obj) { 
        Shader shader = Obj.GetComponent<Renderer>().material.shader;
        List<string> shaderProperties = new List<string>();
        int PropertyCount = shader.GetPropertyCount();

        for (int i = 0; i < PropertyCount; i++) {
            shaderProperties.Add(shader.GetPropertyName(i));
        }

        return shaderProperties;
    }
    public static string GetCurrentMap() { 
        return MapLoaderBehaviour.CurrentMap.Prefab.name;
    }
}