using System;
using UnityEngine;
using UnityEngine.Events;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Reflection;
using System.Text;
using UnityEngine.SceneManagement;

namespace Mod
{
    public class Mod
    {
        public static void Main()
        {
ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Plastic Barrel"),
        NameOverride = "Set Map Settings Object (look at desc VV)",
        DescriptionOverride = "Right click on this object for map settings, such as color",
        CategoryOverride = ModAPI.FindCategory("Misc."),
        ThumbnailOverride = ModAPI.LoadSprite("ColorableBoxThumb.png"),
        AfterSpawn = (Instance) =>
        { 
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Box.png");
            Instance.FixColliders();
            Instance.AddComponent<ColorableBounds>();
        }  
    }
);
        }
    }
    public class ColorableBounds : MonoBehaviour {
        public Color BaseColor = new Color(255, 255, 255);
        List<ContextMenuButton> buttonsList;

        public void Start() {
            buttonsList = this.gameObject.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons;

            ContextMenuButton setMBColor = new ContextMenuButton(() => true, "setMBColor", "Set Map Bounds Color", "Set Map Bounds Color", new UnityAction[1]
            {
                (UnityAction) (() => Utils.OpenColourInputDialog<ColorableBounds>(BaseColor, "Pick a colour", "Set color for the map bounds.", (System.Action<ColorableBounds, Color>) ((obj, c) =>
                {
                    GameObject.Find("Root/Left wall").GetComponent<SpriteRenderer>().color = c;
                    GameObject.Find("Root/Right wall").GetComponent<SpriteRenderer>().color = c;
                    GameObject.Find("Root/Ceiling").GetComponent<SpriteRenderer>().color = c;
                    GameObject.Find("Root").GetComponent<SpriteRenderer>().color = c;
                    if ((bool) GameObject.Find("Coast (1)")) { 
                       GameObject.Find("Coast (1)").GetComponent<SpriteRenderer>().color = c; 
                       GameObject.Find("Coast (2)").GetComponent<SpriteRenderer>().color = c; 
                    }
                })))
            });
            ContextMenuButton setBGColor = new ContextMenuButton(() => true, "setBGColor", "Set Background Color", "Set Background Color", new UnityAction[1]
            {
                (UnityAction) (() => Utils.OpenColourInputDialog<ColorableBounds>(BaseColor, "Set Background Color", "Set color for the background.", (System.Action<ColorableBounds, Color>) ((obj, c) =>
                {
                    GameObject.Find("Panels").GetComponent<Renderer>().material.SetColor("_FadeColour", c);
                    GameObject.Find("Panels").GetComponent<Renderer>().material.SetColor("_ColourVariation", c);

                })))
            });
            ContextMenuButton setWaterColor = new ContextMenuButton(() => true, "setWaterColor", "Set Water Color", "Set Water Color", new UnityAction[1]
            {
                (UnityAction) (() => Utils.OpenColourInputDialog<ColorableBounds>(BaseColor, "Set Water Color", "Set color for the Water.", (System.Action<ColorableBounds, Color>) ((obj, c) =>
                {
                    if ((bool) GameObject.Find("Sea"))
                    {
                        GameObject.Find("Sea").GetComponent<Renderer>().material.SetColor("_Tint", c);
                    }
                    if (DebugAPI.GetCurrentMap() == "Substructure") { 
                        GameObject.Find("Pool").GetComponent<Renderer>().material.SetColor("_Tint", c);
                        GameObject.Find("Pool (1)").GetComponent<Renderer>().material.SetColor("_Tint", c);
                    }
                })))
            });
            buttonsList.Add(setWaterColor);
            buttonsList.Add(setMBColor);
            buttonsList.Add(setBGColor);
        }
    }
}
